<template>
  <q-page padding class="fit row wrap item-start justify-start">
    <div class="row q-gutter-md">
      <h4>{{currentQuiz.name}}</h4>
      <q-stepper
        v-model="step"
        header-nav
        ref="stepper"
        color="primary"
        animated
      >
        <q-step
          v-for="(question, index) in quizQuestions"
          v-bind:key="index"
          icon="create"
          v-bind:name="index"
          v-bind:title="'Pregunta '+ (index + 1)"
          v-bind:done="step > index"
        >
          <question-card-creation
            v-on:saving="onSubmit"
            v-bind:options="currentQuiz.labels"
            v-bind:defaultTags="area"
            v-bind:defaultQuestion="question"
            v-bind:pointsLeft="currentQuiz.totalPoints - nPoints.reduce((a,b) => a+b, 0)"
            v-bind:pointsUsed="nPoints[index]"
            class="col-auto"
          />
        </q-step>
        <q-step
          icon="close"
          title="Cerrar"
          v-bind:name="quizQuestions.length"
        >
          <q-card flat class="col-4">
            <q-card-section>
              <div class="text-h6">Terminar trabajo</div>
            </q-card-section>
            <q-card-section class="q-pt-none">
              Si desea continuar con la evaluación anterior, hagá click en los botones de navegación. Si desea terminar, haga click en "Completar".
            </q-card-section>
            <q-card-section>
              <q-btn label="Completar" color="secondary" v-on:click="endQuiz"/>
            </q-card-section>
          </q-card>
        </q-step>
      </q-stepper>

      <div class="col-auto q-pa-md">
        <div class="text-body1 q-gutter-x-xs">Temas restantes:
          <q-chip
            v-for="(theme, index) in currentThemes"
            v-bind:key="index"
          >
            <q-avatar color="primary" text-color="white">{{theme.number}}</q-avatar>
              {{theme.name}}
          </q-chip>
        </div>
        <div class="text-body1 q-gutter-x-xs">Habilidades restantes:
          <q-chip
            v-for="(skill, index) in currentSkills"
            v-bind:key="index"
          >
            <q-avatar color="secondary" text-color="white">{{skill.number}}</q-avatar>
              {{skill.name}}
          </q-chip>
        </div>
      </div>
      <div>
        <div class="text-h6 q-pa-md">Preguntas sugeridas para sus temas:</div>
        <div class="q-pa-xs row items-start q-gutter-x-xs">
          <question-card
            v-for="(question, index) in questions"
            v-bind:key="index"
            v-bind:question="question"
            v-bind:copyable="true"
            v-bind:replaceable="true"
            v-on:replaceQuestion="onChangeQuestion"
            v-on:copyQuestion="onCopyQuestion"
          />
        </div>
      </div>
    </div>
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'QuizCreationAdd',
  components: {
    QuestionCard: () => import('../../components/question/QuestionCard'),
    QuestionCardCreation: () => import('../../components/question/QuestionCardCreation')
  },
  data () {
    return {
      questions: [],
      nPoints: [],
      area: [],
      themes: [],
      skills: [],
      quizQuestions: [],
      step: 0
    }
  },
  computed: {
    ...mapGetters({
      userId: 'auth/getId',
      currentQuiz: 'current/getCurrentQuiz',
      workState: 'current/getWorkState',
      currentArea: 'current/getCurrentArea',
      currentSkills: 'current/getCurrentSkills',
      currentThemes: 'current/getCurrentThemes',
      questionList: 'current/getQuestionList'
    })
  },
  mounted () {
    this.nPoints = new Array(this.currentQuiz.totalQuestions).fill(1)

    this.$store.dispatch('current/setQuestionList', this.currentQuiz.labels)
      .then(() => {
        this.questions = this.getRandomQuestion(3)
      })
    this.area = this.currentArea

    this.quizQuestions = new Array(this.currentQuiz.totalQuestions).fill(null)
    const promises = []
    for (var index in this.currentQuiz.questions) {
      if (this.currentQuiz.questions[index]) {
        promises.push(this.$connection.get('api/questions/' + this.currentQuiz.questions[index].questionId))
        this.nPoints[index] = this.currentQuiz.questions[index].assignedPoints
      }
    }
    Promise.all(promises)
      .then((results) => {
        for (var index in results) {
          this.quizQuestions[index] = results[index].data
        }
      })
  },
  methods: {
    endQuiz () {
      this.$q.dialog({
        title: 'Confirmar fin de la evaluación',
        message: '¿Quiere guardar su evaluación?',
        cancel: true,
        persistent: true
      }).onOk(() => {
        this.$store.dispatch('current/endCurrentQuiz', true)
          .then(() => {
            this.$router.push('/quiz/revision')
          })
      }).onOk(() => {
        console.log('>>>> second OK catcher')
      }).onCancel(() => {
        this.step = 1
      }).onDismiss(() => {
        this.step = 1
      })
    },
    getRandomQuestion (amount) {
      var result = new Array(amount),
        len = this.questionList.length,
        taken = new Array(len)
      if (len < amount) { return this.questionList }
      while (amount--) {
        var x = Math.floor(Math.random() * len)
        result[amount] = this.questionList[x in taken ? taken[x] : x]
        taken[x] = --len in taken ? taken[len] : len
      }
      return result
    },
    onSubmit (val, reset) {
      this.$store.dispatch('current/sendCurrentQuiz', val)
        .then(() => {
          this.quizQuestions[this.step - 1] = val
          this.nPoints[this.step - 1] = val.points
          this.step += 1
        })
        .catch(() => this.$store.dispatch('auth/logOut'))
    },
    onChangeQuestion (val) {
      this.$store.dispatch('current/rejectQuestion', {
        question: val,
        labels: this.currentQuiz.labels,
        userId: this.userId
      })
      const index = this.questions.indexOf(val)
      if (index > -1) {
        this.questions.splice(index, 1)
      }
      this.questions.push(this.questionList[Math.floor(Math.random() * this.questionList.length)])
    },
    onCopyQuestion (val) {
      this.quizQuestions[this.step - 1] = val
      const index = this.questions.indexOf(val)
      if (index > -1) {
        this.questions.splice(index, 1)
        this.$store.dispatch('current/removeQuestion', this.questions[index])
      }
      this.questions.push(this.questionList[Math.floor(Math.random() * this.questionList.length)])
    }
  }
}
</script>
